/*

*/
import java.util.Random;

/**

*/
public class BagTest
{
   private static final int ITERATIONS = 1_000_000;
   private static final int RANDOM_RANGE = 100;

   public static void main(String[] args)
   {
      Random rand = new Random();

      Bag<Integer> bag1 = new ArrayBag<Integer>();
      Bag<Integer> bag2 = new ArraysBag<Integer>();
      Bag<Integer> bag3 = new LinkedBag<Integer>();

      // fill the bags
      for (int i = 0; i < ITERATIONS; i++)
      {
         int element = rand.nextInt(RANDOM_RANGE);
         bag1.add( element );
         bag2.add( element );
         bag3.add( element );
      }

      System.out.println("The bags have been filled.");

      // check that the two bags contain the same thing
      boolean fail = false;
      System.err.println("RANDOM_RANGE=" + RANDOM_RANGE);
      for (int i = 0; i < RANDOM_RANGE; i++)
      {
         int count1 = bag1.countOccurrences( i );
         System.err.print("i=" + i + ", count1=" + count1);
         int count2 = bag2.countOccurrences( i );
         System.err.print(", count2=" + count2);
         int count3 = bag3.countOccurrences( i );
         System.err.println(", count3=" + count3);
         if ( count1 != count2 && count1 != count3 )
         {
            fail = true;
            System.out.println("There is a problem with the Bag implementations.");
         }
      }

      if (! fail)
      {
         System.out.println("The Bag implementations passed the first test.");
      }

      // empty the bags
      System.err.println("RANDOM_RANGE=" + RANDOM_RANGE);
      for (int i = 0; i < RANDOM_RANGE; i++)
      {
         int count = bag2.countOccurrences( i );
         System.err.println("i=" + i + " count=" + count);
         for (int j = 0; j < count; j++)
         {
            bag1.remove(i);
            bag2.remove(i);
            bag3.remove(i);
         }
      }

      // check that the bags are empty
      if ( (0 == bag1.size()) && (0 == bag2.size()) && (0 == bag3.size()) )
      {
         System.out.println("The Bag implementations passed the second test.");
      }
      else
      {
         System.out.println("There is a problem with the Bag implementations.");
      }
   }
}
