/**

*/
public class Section5_1
{
   public static void main(String[ ] args)
   {
      // Examples of "widening" and "narrowing" conversions and assignments.

      // Using primitive types.
      int n = 2;
      float x = n;  // this is really a "widening conversion"
      double y = x; // this is another widening conversion
      n = (int)y;   // this is a "narrowing conversion"

      // Now using reference types.
      String s = new String("Objection overruled!");
      Object obj = s;  // a widening "conversion" (or assignment)

      s = new String("Make it so.");  // Make s refer to a new string value.

      // Make s refer back to its original string value.
      s = obj;          // This doesn't work! It is a narrowing assignment.
      s = (String)obj;  // This works. We cast the narrowing assignment to the correct type.

      obj = new java.awt.Color(1,1,1);
      s = (String)obj; // But you can't cast just anything to what it is you want.



      // Examples of wrapper classes, boxing, unboxing, autoboxing, auto-unboxing.

      int i =42;
      Integer example = new Integer(i); // Put a "wrapper" class object around the value of i (boxing).
      int j = example.intValue();       // Unwrap the value from the wrapper class object (unboxing).

      i = 52;
      example = i;  // "autobox" the int value of i in a wrapper class object
      j = example;  // "auto-unbox" the int value from the wrapper class object

   }//main()
}//Section5_1
