/*
   A "comparable" Box. We will use a box's volume
   to decide which of two boxes is "bigger".
*/

public class Box implements Comparable<Box>
{
   private int x;
   private int y;
   private int z;

   public Box(int x, int y, int z)
   {
      this.x = x;
      this.y = y;
      this.z = z;
   }

   public int getX() { return x; }
   public int getY() { return y; }
   public int getZ() { return z; }

   public int volume()
   {
      return x * y * z;
   }

   /**
      Implement the Comparable<Box> interface.
   */
   public int compareTo(Box b)
   {
      return (this.volume() - b.volume());
   }

   /**
      Override toString().
   */
   public String toString()
   {
      return "Box(" + x + ", " + y + ", " + z + ")";
   }
}
