/*
   Use the comparable Box class, the Max class,
   and Box comparator objects to do some "generic"
   comparisons of Box objects.
*/
import java.util.Comparator;

public class CompareBoxes
{
   public static void main(String[] args)
   {
      Box box1 = new Box(1, 2, 3);
      Box box2 = new Box(3, 2, 1);
      Box box3 = new Box(2, 2, 2);

      // Compare boxes by their "natural ordering".
      System.out.println("Max.max(" + box1 + ", " + box2 + ") = "
                             + Max.max(box1, box2));
      System.out.println("Max.max(" + box2 + ", " + box3 + ") = "
                             + Max.max(box2, box3));

      System.out.println("Max.max(" + box1 + ", " + box2 + ", " + box3 + ") = "
                             + Max.max(box1, box2, box3));


      // Create a comparator that can order boxes by their x-value.
      Comparator<Box> cmpX = new CmpByX();

      System.out.println("Max.max(" + box1 + ", " + box2 + ", " + "cmpX) = "
                             + Max.max(box1, box2, cmpX));
      System.out.println("Max.max(" + box2 + ", " + box3 + ", " + "cmpX) = "
                             + Max.max(box2, box3, cmpX));

      System.out.println("Max.max(" + box1 + ", " + box2 + ", " + box3 + ", " + "cmpX) = "
                             + Max.max(box1, box2, box3, cmpX));


      // Create a comparator that can order boxes by their z-value.
      Comparator<Box> cmpZ = new CmpByZ();

      System.out.println("Max.max(" + box1 + ", " + box2 + ", " + "cmpZ) = "
                             + Max.max(box1, box2, cmpZ));
      System.out.println("Max.max(" + box2 + ", " + box3 + ", " + "cmpZ) = "
                             + Max.max(box2, box3, cmpZ));

      System.out.println("Max.max(" + box1 + ", " + box2 + ", " + box3 + ", " + "cmpZ) = "
                             + Max.max(box1, box2, box3, cmpZ));

   }
}//MaxBox



// Here are the two Comparator classes.
class CmpByX implements Comparator<Box>
{
   public int compare(Box a, Box b)
   {
      return ( a.getX() - b.getX() );
   }
}


class CmpByZ implements Comparator<Box>
{
   public int compare(Box a, Box b)
   {
      return ( a.getZ() - b.getZ() );
   }
}
