/**
   A ridiculous attempt to create a Java version of the
   shorter function (on arrays) that is as generic as
   the Haskell version (on lists).

      shorter :: [a] -> [b] -> Bool
      shorter x y = (length x) < (length y)

   We would need 81 (9 * 9) overloaded versions of shorter()
   to be as generic as Haskell!

   Here are a few of the overloaded versions of shorter().
*/

public class Shorter
{
   public static boolean shorter(char[] x, char[] y)
   {
      return x.length < y.length;
   }

   public static boolean shorter(byte[] x, byte[] y)
   {
      return x.length < y.length;
   }

   public static boolean shorter(short[] x, short[] y)
   {
      return x.length < y.length;
   }

   public static boolean shorter(int[] x, int[] y)
   {
      return x.length < y.length;
   }

   public static boolean shorter(long[] x, long[] y)
   {
      return x.length < y.length;
   }

   public static boolean shorter(float[] x, float[] y)
   {
      return x.length < y.length;
   }

   public static boolean shorter(double[] x, double[] y)
   {
      return x.length < y.length;
   }

   public static boolean shorter(boolean[] x, boolean[] y)
   {
      return x.length < y.length;
   }

   public static boolean shorter(Object[] x, Object[] y)
   {
      return x.length < y.length;
   }

   // We still need a lot more overloaded versions of shorter().

   public static boolean shorter(char[] x, byte[] y)
   {
      return x.length < y.length;
   }

   public static boolean shorter(byte[] x, char[] y)
   {
      return x.length < y.length;
   }

   public static boolean shorter(char[] x, short[] y)
   {
      return x.length < y.length;
   }

   public static boolean shorter(short[] x, char[] y)
   {
      return x.length < y.length;
   }

   public static boolean shorter(char[] x, int[] y)
   {
      return x.length < y.length;
   }

   public static boolean shorter(int[] x, char[] y)
   {
      return x.length < y.length;
   }

   public static boolean shorter(char[] x, Object[] y)
   {
      return x.length < y.length;
   }

   public static boolean shorter(Object[] x, char[] y)
   {
      return x.length < y.length;
   }

   // etc., etc., etc, ...



   public static void main(String[] args)
   {
         int[] a = new int[0];
        char[] c = new char[1];
      double[] d = new double[2];

      boolean r1 = shorter(a, c);
      System.out.println( r1 );
//    boolean r2 = shorter(a, d);
//    System.out.println( r2 );
   }
}
