import java.util.Iterator;
import java.util.NoSuchElementException;

/**
   Make the iterator iterable.
*/
public class It3 implements Iterator<Integer>, Iterable<Integer>
{
  private int start;
  private int end;

  public It3(int x, int y)
  {
    start = x;
    end = y;
  }

  public boolean hasNext()
  {
    return start <= end;
  }

  public Integer next()
  {
    if ( ! this.hasNext() )
       throw new NoSuchElementException();

    int result = start;
    start++;
    return result;
  }

  public void remove()
  {
    throw new UnsupportedOperationException ();
  }

  public Iterator<Integer> iterator()
  {
    return this;
  }
}
